<script setup lang="ts">
import Flex from "@/components/atoms/container/Flex.vue";
import ActionButton from "@/components/atoms/button/ActionButton.vue";
import ShortcutText from "@/components/atoms/text/shorcut/ShortcutText.vue";
import MergeRequest from "@/entities/MergeRequest/MergeRequest";
import ExternalLink from "@/components/atoms/link/ExternalLink.vue";
import DependencyList from "@/components/organisms/list/MergeRequest/DependencyList.vue";
import {findShortcutWithShortcutEnum, SHORTCUTS} from "@/constants/SHORTCUTS_PER_SECTION";
import {computed, ref} from "vue";
import {MergeRequestApiHandler} from "@/handlers/MergeRequestApiHandler";
import {VersionApiHandler} from "@/handlers/VersionApiHandler";

const props = defineProps<{
  mergeRequest: MergeRequest,
  hasFocus: boolean,
  updateMergeRequestHandler: undefined | Function,
  processMergeRequestHandler: undefined | Function,
  disabled: undefined | Boolean
}>()

const mergeRequestHandler = new MergeRequestApiHandler();
const versionHandler = new VersionApiHandler();

const focusOnMrDependenciesShortcut = computed(() => findShortcutWithShortcutEnum(SHORTCUTS.MR_DEPENDENCY));
const focusOnVersionDependenciesShortcut = computed(() => findShortcutWithShortcutEnum(SHORTCUTS.VERSION_DEPENDENCY));


const searchMergeRequestNotAlreadyInDependencies = async (query: String) => {
  return await mergeRequestHandler.list({
    'search': query,
    'excludes_merge_request_dependencies': props.mergeRequest.uri,
    'exists[closedAt]': false,
  });
}

const searchVersionNotAlreadyInDependencies = async (query: String) => {
  return await versionHandler.list({
    'search': query,
    'excludes_merge_request_dependencies': props.mergeRequest.uri,
  });
}

const isOnSave = ref<Boolean>(false);

</script>

<template>
  <Flex class="flex-col justify-between w-1/4">
    <Flex class="flex-col p-container gap-content">
      <ExternalLink :href="mergeRequest?.link">
        Lien vers la MR
      </ExternalLink>
      <ExternalLink :href="mergeRequest?.repository?.link">
        {{ mergeRequest?.repository?.name }}
      </ExternalLink>
      <span v-if="mergeRequest.mergedAt">
        Mergée le {{ mergeRequest.mergedAt.toLocaleDateString() }}
      </span>
      <hr/>
      <DependencyList
          dependencyType="MR/PR"
          v-model:dependencies="mergeRequest.mergeRequestDependencies"
          :searchDependencyForQuery="searchMergeRequestNotAlreadyInDependencies"
          :disabled="disabled"
          :updateDependencyHandler="updateMergeRequestHandler"
          :shortcut="focusOnMrDependenciesShortcut"
          :hasFocus="hasFocus"
      />
      <hr/>
      <DependencyList
          dependencyType="Version"
          v-model:dependencies="mergeRequest.versionDependencies"
          :searchDependencyForQuery="searchVersionNotAlreadyInDependencies"
          :disabled="disabled"
          :updateDependencyHandler="updateMergeRequestHandler"
          :shortcut="focusOnVersionDependenciesShortcut"
          :hasFocus="hasFocus"
      />
    </Flex>
    <ActionButton
        v-if="!disabled && processMergeRequestHandler"
        @click="(e) => {
          if(processMergeRequestHandler){
            isOnSave = true;
            processMergeRequestHandler(e).finally(() => isOnSave = false)
          }
        }"
        :notRounded="true"
        :disabled="isOnSave"
    >
      <ShortcutText :shortcut="findShortcutWithShortcutEnum(SHORTCUTS.VALIDATE_MR)?.toString()">Traiter ✓</ShortcutText>
    </ActionButton>
  </Flex>
</template>
